package operations;

import structures.*;

public class PrettyPrinter implements Visitor {
	private String result;
	
	public PrettyPrinter() {
		this.result = "";
	}
	
	public String result() {
		return this.result;
	}
	
	public void visitConstant(Constant ic) {
		this.result += ic.value();
	}
	
	public void visitAddition(Addition add) {
		String[] results = this.visitBinaryOp(add);
		this.result = "(" + results[0] + ")" + " + " + "(" + results[1] + ")";
	}
	
	public void visitSubtraction(Subtraction sub) {
		String[] results = this.visitBinaryOp(sub);
		this.result = "(" + results[0] + ")" + " - " + "(" + results[1] + ")";
	}
	
	private String[] visitBinaryOp(CompositeExpression ce) {
		PrettyPrinter ppL = new PrettyPrinter();
		PrettyPrinter ppR = new PrettyPrinter();
		ce.getLeft().accept(ppL);
		ce.getRight().accept(ppR);
		String resultL = ppL.result();
		String resultR = ppR.result();
		return new String[] {resultL, resultR};
	}
}
